<!--********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->
<style>
  #searchgrid div {
    padding: 0.125rem;
    display: grid;
    align-items: center;
  }
  :host ::ng-deep .tooltip {
    width: 50vw;
  }

  :host ::ng-deep .p-autocomplete .p-autocomplete-multiple-container {
    padding: 0.083rem 0.75rem;
  }
  :host ::ng-deep .p-autocomplete .p-autocomplete-input {
    padding: 0.335rem 0.75rem;
  }
  :host ::ng-deep .p-calendar-w-btn .p-inputtext {
    padding: 0.335rem 0.75rem;
  }
</style>
<div id="searchgrid" style="display: grid; grid-template-columns: 15% 15% minmax(8rem, 5%) auto 3%">
  <div class="d-flex">
    <span class="flex-grow-1">{{ condition.type | mdmTranslate : defaultSourceName | async }}</span>
    <span
      *ngIf="condition?.isCurrentlyLinked"
      class="fa fa-link linked-icon"
      pTooltip="{{ 'search.search-condition.condition-is-linked' | translate }}"
    ></span>
    <span
      *ngIf="!condition?.isCurrentlyLinked && condition?.isCreatedViaLink"
      class="fa fa-unlink unlinked-icon"
      pTooltip="{{ 'search.search-condition.condition-created-via-link' | translate }}"
    ></span>
  </div>
  <!-- | translate -->
  <div>{{ condition.type | mdmTranslate : defaultSourceName : condition.attribute | async }}</div>
  <!--  | translate: condition.attribute -->
  <div>
    <p-dropdown
      styleClass="w-full"
      [options]="operators"
      [(ngModel)]="condition.operator"
      (onChange)="operatorChanged($event)"
      [title]="'search.search-condition.tooltip-select-search-operator' | translate"
    ></p-dropdown>
  </div>
  <div style="display: flex" [ngSwitch]="condition.valueType">
    <ng-container
      *ngSwitchCase="
        condition.valueType === 'string' ||
        condition.valueType === 'string_sequence' ||
        condition.valueType === 'enumeration' ||
        condition.valueType === 'enumeration_sequence'
          ? condition.valueType
          : ''
      "
    >
      <p-autoComplete
        #multi
        *ngIf="isHandlingMultipleValues"
        [(ngModel)]="condition.value"
        [autoHighlight]="true"
        [suggestions]="suggestions"
        (completeMethod)="updateSuggestions($event)"
        [multiple]="true"
        [delay]="300"
        [size]="500"
        [scrollHeight]="'50vh'"
        [placeholder]="'administration.edit-preference.lbl-value' | translate"
        [disabled]="disabled"
        [forceSelection]="false"
        (keyup.enter)="onEnter($event, multi)"
        (onBlur)="onAutocompleteBlur($event, multi)"
        (click)="onClickAutoComplete($event, multi)"
        (onSelect)="onSelect($event, multi)"
        [style]="{ width: '100%', 'flex-grow': '1' }"
        [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
        class="w-full flex-grow-1"
        [pTooltip]="'search.search-condition.multi-value-input' | translate"
        tooltipPosition="bottom"
        showDelay="1000"
        tooltipStyleClass="tooltip"
        appendTo="body"
      >
        <ng-template let-item pTemplate="selectedItem">
          <div (click)="renameItem(item, condition)">{{ item }}</div>
        </ng-template>
      </p-autoComplete>
      <p-autoComplete
        #first
        *ngIf="!isHandlingMultipleValues"
        [(ngModel)]="stringValueStart"
        [autoHighlight]="true"
        [suggestions]="suggestions"
        (completeMethod)="updateSuggestions($event)"
        [multiple]="false"
        [delay]="300"
        [size]="500"
        [scrollHeight]="'50vh'"
        [placeholder]="'administration.edit-preference.lbl-value' | translate"
        [disabled]="disabled"
        (keyup.enter)="setValue()"
        (onBlur)="setValue()"
        (onSelect)="setValue()"
        [style]="{ width: '100%', 'flex-grow': '1' }"
        [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
        class="w-full flex-grow-1"
        [pTooltip]="'search.search-condition.single-value-input' | translate"
        tooltipPosition="bottom"
        showDelay="1000"
        tooltipStyleClass="tooltip"
        appendTo="body"
      >
      </p-autoComplete>
      <ng-container *ngIf="isBinaryOperator">
        <span style="padding: 0 0.75rem; text-align: center; display: inline-block">{{ "search.search-condition.and" | translate }}</span>
        <p-autoComplete
          #second
          [(ngModel)]="stringValueEnd"
          [autoHighlight]="true"
          [suggestions]="suggestions"
          (completeMethod)="updateSuggestions($event)"
          [multiple]="false"
          [delay]="300"
          [size]="500"
          [scrollHeight]="'50vh'"
          [placeholder]="'administration.edit-preference.lbl-value' | translate"
          [disabled]="disabled"
          (keyup.enter)="setValue()"
          (onBlur)="setValue()"
          (onSelect)="setValue()"
          [style]="{ width: '100%', 'flex-grow': '1' }"
          [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
          class="w-full flex-grow-1"
          [pTooltip]="'search.search-condition.single-value-input' | translate"
          tooltipPosition="bottom"
          showDelay="1000"
          tooltipStyleClass="tooltip"
          appendTo="body"
        >
        </p-autoComplete>
      </ng-container>
    </ng-container>

    <ng-container *ngSwitchCase="condition.valueType === 'date' || condition.valueType === 'date_sequence' ? condition.valueType : ''">
      <p-calendar
        (ngModelChange)="setDateValue($event, 0)"
        [ngModel]="dateValue"
        dateFormat="dd.mm.yy"
        showTime="true"
        hourFormat="24"
        hideOnDateTimeSelect="true"
        [showIcon]="true"
        [disabled]="disabled"
        [style]="{ width: '100%', 'flex-grow': '1' }"
        [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
        class="w-full flex-grow-1"
        [pTooltip]="'search.search-condition.single-value-input' | translate"
        tooltipPosition="bottom"
        showDelay="1000"
        tooltipStyleClass="tooltip"
        appendTo="body"
      >
      </p-calendar>
      <ng-container *ngIf="isBinaryOperator">
        <span style="padding: 0 0.75rem; text-align: center; display: inline-block">{{ "search.search-condition.and" | translate }}</span>
        <p-calendar
          *ngSwitchCase="condition.valueType === 'date' || condition.valueType === 'date_sequence' ? condition.valueType : ''"
          (ngModelChange)="setDateValue($event, 1)"
          [ngModel]="dateValueEnd"
          dateFormat="dd.mm.yy"
          showTime="true"
          hourFormat="24"
          hideOnDateTimeSelect="true"
          [showIcon]="true"
          [disabled]="disabled"
          [style]="{ width: '100%', 'flex-grow': '1' }"
          [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
          class="w-full flex-grow-1"
          [pTooltip]="'search.search-condition.single-value-input' | translate"
          tooltipPosition="bottom"
          showDelay="1000"
          tooltipStyleClass="tooltip"
          appendTo="body"
        >
        </p-calendar>
      </ng-container>
    </ng-container>

    <ng-container *ngSwitchDefault>
      <input
        pInputText
        type="text"
        [placeholder]="'administration.edit-preference.lbl-value' | translate"
        [disabled]="disabled"
        [(ngModel)]="stringValueStart"
        (input)="setValue()"
        [pTooltip]="'search.search-condition.single-value-input' | translate"
        tooltipPosition="bottom"
        showDelay="1000"
        tooltipStyleClass="tooltip"
        [style]="{ width: '100%', 'flex-grow': '1' }"
        [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
        class="w-full flex-grow-1"
      />
      <ng-container *ngIf="isBinaryOperator">
        <span style="padding: 0 0.75rem; text-align: center; display: inline-block">{{ "search.search-condition.and" | translate }}</span>
        <input
          pInputText
          type="text"
          [placeholder]="'administration.edit-preference.lbl-value' | translate"
          [disabled]="disabled"
          [(ngModel)]="stringValueEnd"
          (input)="setValue()"
          [pTooltip]="'search.search-condition.single-value-input' | translate"
          tooltipPosition="bottom"
          tooltipStyleClass="tooltip"
          [style]="{ width: '100%', 'flex-grow': '1' }"
          [inputStyle]="{ width: '100%', 'flex-grow': '1' }"
          class="w-full flex-grow-1"
        />
      </ng-container>
    </ng-container>
  </div>
  <div><p-button id="remove" icon="pi pi-times remove" (onClick)="remove()" [disabled]="disabled"></p-button></div>
</div>
